;------------------------------------------------------------------------------------------------
; HET Registers definitions
;------------------------------------------------------------------------------------------------
hetPORT2 		.set 	0xFFF7B94C
hetBaseH 		.set 	0xFFF7
het1BaseL 		.set 	0xB800			;Base adresse of HET1 = 0xFFF7B800
het2BaseL 		.set 	0xB900			;Base adresse of HET2 = 0xFFF7B900
het1BaseAdd		.set 	0xFFF7B800		;Base adresse of HET1 = 0xFFF7B800
het2BaseAdd		.set 	0xFFF7B900		;Base adresse of HET2 = 0xFFF7B900

het1RamAdd		.set	0xFF460000		;Address of HET1 RAM
het2RamAdd		.set	0xFF440000		;Address of HET2 RAM

;NHET1RAMPARLOC	.set	0xFF462000
;NHET1RAMLOC	.set	0xFF46
;NHET2RAMPARLOC	.set	0xFF442000
;NHET2RAMLOC	.set	0xFF44

;0xFF460000U

het_GCR     .set 0x0000	; Global control register
het_PFR     .set 0x0004	; Prescale factor register
het_ADDR    .set 0x0008	; Current address register
het_OFF1    .set 0x000C	; Interrupt offset register 1
het_OFF2    .set 0x0010	; Interrupt offset register 2
het_INTENAS .set 0x0014	; Interrupt enable set register
het_INTENAC .set 0x0018	; Interrupt enable clear register
het_EXC1    .set 0x001C	; Exception control register 1
het_EXC2    .set 0x0020	; Exception control register 2
het_PRY     .set 0x0024	; Interrupt priority register
het_FLG     .set 0x0028	; Interrupt flag register
het_AND     .set 0x002C	; AND share control register
het_rsvd1 	.set 0x0030	; Reserved
het_HRSH    .set 0x0034	; High resolution share register
het_XOR     .set 0x0038	; XOR share register
het_REQENS  .set 0x003C	; Request enable set register
het_REQENC  .set 0x0040	; Request enable clear register
het_REQDS   .set 0x0044	; Request destination select register
het_rsvd2   .set 0x0048	; Reserved
het_DIR     .set 0x004C	; Direction register
het_DIN     .set 0x0050	; Data input register
het_DOUT    .set 0x0054	; Data output register
het_DSET    .set 0x0058	; Data output set register
het_DCLR    .set 0x005C	; Data output clear register
het_PDR     .set 0x0060	; Open drain register
het_PULDIS  .set 0x0064	; Pull disable register
het_PSL 	.set 0x0068	; Pull select register
het_rsvd3   .set 0x006C	; Reserved
het_rsvd4   .set 0x0070	; Reserved
het_PCR     .set 0x0074	; Parity control register :
het_PAR     .set 0x0078	; Parity address register :
het_PPR     .set 0x007C	; Parity pin select register
het_SFPRLD  .set 0x0080	; Suppression filter preload register
het_SFENA   .set 0x0084	; Suppression filter enable register
het_rsvd5   .set 0x0088	; Reserved
het_LBPSEL  .set 0x008C	; Loop back pair select register
het_LBPDIR  .set 0x0090	; Loop back pair direction register

;------------------------------------------------------------------------------------------------
; GIO Registers definitions
;------------------------------------------------------------------------------------------------
gioBaseREGH   		.set 			0xFFF7			;gioREG Base address High
gioBaseREGL   		.set 			0xBC00			;gioREG Base address Low
gioBaseREG   		.set 			0xFFF7BC00		;gioREG Base address
gioBasePORTAH 		.set 			0xFFF7			;gioPORTA Base address High
gioBasePORTAL 		.set 			0xBC34			;gioPORTA Base address Low
gioBasePORTA 		.set 			0xFFF7BC34		;gioPORTA Base address
gioBasePORTB 		.set 			0xFFF7BC54		;gioPORTB Base address

; structure of gioBase Registers
;-------------------------------
gio_GCR0          	.set          	0x0000    ; Global Control Register */
gio_rsvd          	.set          	0x0004    ; Reserved*/
gio_INTDET          .set          	0x0008    ; Interrupt Detect Register*/
gio_POL          	.set          	0x000C    ; Interrupt Polarity Register */
gio_ENASET          .set          	0x0010    ; Interrupt Enable Set Register */
gio_ENACLR          .set          	0x0014    ; Interrupt Enable Clear Register */
gio_LVLSET          .set          	0x0018    ; Interrupt Priority Set Register */
gio_LVLCLR          .set          	0x001C    ; Interrupt Priority Clear Register */
gio_FLG          	.set          	0x0020    ; Interrupt Flag Register */
gio_OFF1          	.set          	0x0024    ; Interrupt Offset 1 Register High level
gio_OFF2          	.set          	0x0028    ; Interrupt Offset 2 Register Low Level
; structure of gioPort
;---------------------
gio_DIR          	.set          	0x0000    ; Data Direction Register */
gio_DIN          	.set          	0x0004    ; Data Input Register */
gio_DOUT          	.set          	0x0008    ; Data Output Register */
gio_DSET          	.set          	0x000C    ; Data Output Set Register */
gio_DCLR          	.set          	0x0010    ; Data Output Clear Register */
gio_PDR          	.set          	0x0014    ; Open Drain Register */
gio_PULDIS          .set          	0x0018    ; Pullup Disable Register */
gio_PSL          	.set          	0x001C    ; Pull Up/Down Selection Register */

het_PINDIS  .set 0x0094	; Pin disable register

;------------------------------------------------------------------------------------------------
; RTI Registers definitions
;------------------------------------------------------------------------------------------------
rti_REG_BaseAddress	.set 0xFFFFFC00      ; Base address of RTI Register

rti_GCTR           	.set 0x0000          ; Global Control Register   */
rti_TBCTRL         	.set 0x0004          ; Timebase Control Register */
rti_CAPCTRL        	.set 0x0008          ; Capture Control Register  */
rti_COMPCTRL       	.set 0x000C          ; Compare Control Register  */
rti_FRC0           	.set 0x0010          ; Free Running Counter 0 Register         */
rti_FRC1           	.set 0x0030          ; Free Running Counter 1 Register         */
rti_UC0            	.set 0x0014          ; Up Counter 0 Register                   */
rti_UC1            	.set 0x0034          ; Up Counter 1 Register                   */
rti_CPUC0          	.set 0x0018          ; Compare Up Counter 0 Register           */
rti_CPUC1          	.set 0x0038          ; Compare Up Counter 1 Register           */
rti_rsvd0          	.set 0x001C          ; Reserved                                */
rti_rsvd1          	.set 0x003C          ; Reserved                                */
rti_CAFRC0         	.set 0x0020          ; Capture Free Running Counter 0 Register */
rti_CAFRC1         	.set 0x0040          ; Capture Free Running Counter 1 Register */
rti_CAUC0          	.set 0x0024          ; Capture Up Counter 0 Register           */
rti_CAUC1          	.set 0x0044          ; Capture Up Counter 1 Register           */
rti_rsvd2	   		.set 0x0028          ; Reserved                                */
rti_rsvd3      		.set 0x0048          ; Reserved                                */

rti_COMP0          	.set 0x0050          ; Compare 0 Register        */
rti_COMP1          	.set 0x0058          ; Compare 1 Register        */
rti_COMP2      		.set 0x0060          ; Compare 2 Register        */
rti_COMP3          	.set 0x0068          ; Compare 3 Register        */
rti_UDCP0          	.set 0x0054          ; Update Compare 0 Register */
rti_UDCP1          	.set 0x005C          ; Update Compare 1 Register */
rti_UDCP2          	.set 0x0064          ; Update Compare 2 Register */
rti_UDCP3          	.set 0x006C          ; Update Compare 3 Register */

rti_TBLCOMP        	.set 0x0070          ; External Clock Timebase Low Compare Register   */
rti_TBHCOMP        	.set 0x0074          ; External Clock Timebase High Compare Register  */
rti_rsvd4      		.set 0x0078          ; Reserved                                       */
rti_SETINTENA      	.set 0x0080          ; Set/Status Interrupt Register                  */
rti_CLEARINTENA    	.set 0x0084          ; Clear/Status Interrupt Register                */
rti_INTFLAG        	.set 0x0088          ; Interrupt Flag Register                        */
rti_rsvd5          	.set 0x008C          ; Reserved                                       */
rti_DWDCTRL        	.set 0x0090          ; Digital Watchdog Control Register   */
rti_DWDPRLD        	.set 0x0094          ; Digital Watchdog Preload Register */
rti_WDSTATUS       	.set 0x0098          ; Watchdog Status Register  */
rti_WDKEY          	.set 0x009C          ; Watchdog Key Register  */
rti_DWDCNTR        	.set 0x00A0          ; Digital Watchdog Down Counter   */
rti_WWDRXNCTRL     	.set 0x00A4          ; Digital Windowed Watchdog Reaction Control */
rti_WWDSIZECTRL    	.set 0x00A8          ; Digital Windowed Watchdog Window Size Control  */
rti_INTCLRENABLE   	.set 0x00AC          ; RTI Compare Interrupt Clear Enable Register  */
rti_COMP0CLR       	.set 0x00B0          ; RTI Compare 0 Clear Register   */
rti_COMP1CLR       	.set 0x00B4          ; RTI Compare 1 Clear Register */
rti_COMP2CLR       	.set 0x00B8          ; RTI Compare 2 Clear Register  */
rti_COMP3CLR       	.set 0x00BC          ; RTI Compare 3 Clear Register  */

