;-------------------------------------------------------------------------------
;main_.asm
;
; Test multi libraries of april 2018
;
; Main Application program
;-------------------------------------------------------------------------------

				.include	HET_GIO_RTI_Registers.asm

;				.mlib		RM48_GIO_HET_RTI.mlib		; contains macro-instructions for GIO, HET, RTI

				.mlib		RM48_GIO_Mac_v39.mlib		; contains macro-instructions for GIO
				.mlib		RM48_HET_Mac_v40.mlib		; contains macro-instructions for HET
				.mlib		RM48_RTI_Mac_v40.mlib		; contains macro-instructions for RTI

				.arm

;--------------------------------------------------------------------------------------------------------------------------------------------------------------------
				.global			assMain
White_LD_LR 	.set			1 << 00 				;LED Low Right;
rti_flg_CNT0EN 	.set 			0x01					;Counter 0 enable. This bit starts and stops counter block 0

$rti_REG_Base	.word			rti_REG_BaseAddress
$het1BaseAdd	.word			het1BaseAdd
$gioBasePORTA	.word			gioBasePORTA
$delay			.word			1000000					;RTI delay

				hetEnable_rg	r11,r0,het1RamAdd		;Only for test libraries purpose (Enable interrupt in NHET Register)


assMain			.equ			$						;test main assembly program

				ldr				r10,$rti_REG_Base		;r10 = Pointer on RTI
				rtiStartCnt		r10,r0,rti_flg_CNT0EN	;Start Counter 0

				ldr				r12,$het1BaseAdd		;r12 = pointer on N2HET1

				ldr				r11,$gioBasePORTA		;r11 = Pointer on GIO Port A

				ldr				r2,$delay				;r2 = delay

assMain_ml		.equ			$						;Main loop of test main assembly program

				hetSetOut		r12,White_LD_LR			;Turn On the LED Low Right
				gioSetOut		r12,White_LD_LR			;Turn On the user LED 1

				ldr				r0,[r10,#rti_FRC0]		;r0 = free runing counter 0
assMain_1		ldr				r1,[r10,#rti_FRC0]		;r1 = free runing counter 0
				sub				r1,r1,r0
				cmp				r2,r1					;test delay
				bpl				assMain_1

				hetClrOut		r12,White_LD_LR			;Turn Off the LED Low Right
				gioClrOut		r12,White_LD_LR			;Turn On the user LED 1

				ldr				r0,[r10,#rti_FRC0]		;r0 = free runing counter 0
assMain_2		ldr				r1,[r10,#rti_FRC0]		;r1 = free runing counter 0
				sub				r1,r1,r0
				cmp				r2,r1					;test delay
				bpl				assMain_2


				b				assMain_ml

