/*----------------------------------------------------------------------------*/
/* sys_link.cmd                                                               */
/*                                                                            */
/* Copyright ASRTOS (C) 2018 Jerome Beauvais All rights reserved. 					  */
/*                                                                            */
/*----------------------------------------------------------------------------*/

/*----------------------------------------------------------------------------*/
/* Linker Settings                                                            */

--retain="*(.intvecs)"
--retain="*(.varbl)"
--retain="*(.data)"
--retain="*(.textasm)"

/*----------------------------------------------------------------------------*/
/* Memory Map                                                                 */

MEMORY
{
    VECTORS (X)  : origin=0x00000000 length=0x00000020		/* Vectors defined by HCG or ASRTOS*/
    FLASH0  (RX) : origin=0x00000020 length=0x0017FFE0		/* Initialization Program produced by HCG*/
    FLASH1  (RX) : origin=0x00180000 length=0x00180000		/* Reserved for ASRTOS Application assembly Programms */
    STACKS  (RW) : origin=0x08000000 length=0x00000800		/* Reserved for System Stacks by HCG then ASRTOS*/
    STTASK  (RW) : origin=0x08000800 length=0x00020800		/* Reserved for Tasks Stacks by ASRTOS*/
    STSCHE  (RW) : origin=0x08021000 length=0x00001000		/* Reserved for Schedulers Stacks by ASRTOS*/
    TASKVB  (RW) : origin=0x08022000 length=0x00010000		/* Reserved for Tasks Buffer and Queues*/
  	RAM1  	(RW) : origin=0x08032000 length=0x007CDFFF	    /* Reserved for floating point constants*/
}
/*-----------------------------------------------------------------------------*/
/* Sections Configuration
                                                    */
SECTIONS
{
    .intvecs : {} > VECTORS
    .reset   : {} > VECTORS
    .text    : {} > FLASH0
    .const   : {} > FLASH0
    .cinit   : {} > FLASH0
    .pinit   : {} > FLASH0
    .textasm : {} > FLASH1		/* Reserved for assembly program*/

    .bss     : {} > RAM1
    .data    : {} > RAM1
	.secmn_st: {} > STACKS		/* Reserved for main stacks */
	.secta_st: {} > STTASK		/* Reserved for tasks stacks */
	.secsc_st: {} > STSCHE		/* Reserved for schedulers stacks */
    .varTask : {} > TASKVB		/* Reserved for tasks Buffers and Queues */
}


